package rocks.zipcode.quiz5.objectorientation.account;



/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable {

    private Double val;


    public void setBalance(Double val) {

        this.val = val;

    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        if( amountToIncreaseBy < 0) {

            throw new IllegalArgumentException();

        }else{
            this.val += amountToIncreaseBy;
        }
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {

        if( val < amountToDecreaseBy) {
            throw new IllegalArgumentException();
        }else if(amountToDecreaseBy < 00.0) {
            throw new IllegalArgumentException();

        }else{
            this.val -= amountToDecreaseBy;
        }
    }

    @Override
    public Double getBalance() {

        return this.val;
    }
}
