package rocks.zipcode.quiz5.collections;

import rocks.zipcode.quiz5.objectorientation.Spice;

import java.util.*;

/**
 * @author leon on 27/12/2018.
 */
public class Food  {
    List<Spice> listing = new LinkedList<>();

    public List<Spice> getAllSpices() {

        return listing;
    }

    public <SpiceType extends Class<? extends Spice>> Map<SpiceType, Integer> getSpiceCount() {




            Map<SpiceType, Integer> amountOfPeppers = new HashMap<>();

            listing.forEach((spice->{
                if(!amountOfPeppers.containsKey(spice.getClass())) {

                    amountOfPeppers.put((SpiceType) spice.getClass(), 1);
                }else{
                    amountOfPeppers.put((SpiceType)spice.getClass(),amountOfPeppers.get(spice.getClass())+1);

                }
            }));

            return amountOfPeppers;

    }

    public void applySpice(Spice spice) {
        listing.add(spice);
    }
}
