package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.charAt(string.length()/2);
    }

    public static String capitalizeMiddleCharacter(String str) {


      String middle = getMiddleCharacter(str).toString();
      String upper = middle.toUpperCase();

        if(str.length() == 1){
            return str.toUpperCase();
        }else

          return str.substring(0,middle.length()) + upper + str.substring(middle.length()+1);

    }

    public static String lowerCaseMiddleCharacter(String str) {

        String middle = getMiddleCharacter(str).toString();
        String lower = middle.toLowerCase();
        if(str.length() == 1){

            return str.toLowerCase();
        }else if(middle.matches(" ")){
            return str;
        }
        else{
            return str.substring(0,middle.length()) + lower + str.substring(middle.length()+1);
        }

    }

    public static Boolean isIsogram(String str) {

        String [] a = str.split("");

        Set<String> set = new HashSet<String>(Arrays.asList(a));

        if(set.size() == str.length()){
            return true;
        }

        return false;


    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {

        return isIsogram(str);
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        StringBuilder sb = new StringBuilder();
        char [] ch = str.toCharArray();
        int len =0;

        for (int i = 0; i < ch.length; i++) {

            if(  len == 0 || ch[i] != ch[len-1]){
                ch[len++] = ch[i];
            }else{
                len --;
            }
        }
        return new String (ch,0,len);


    }

    public static String invertCasing(String str) {

        char [] ch = str.toCharArray();

        for(int i =0; i<ch.length; i++){
            char c = ch[i];
            if(Character.isUpperCase(c)){
                ch[i] = Character.toLowerCase(c);
            }else if(Character.isLowerCase(c)){
                ch[i] = Character.toUpperCase(c);
            }
        }
        return new String(ch);
    }
}